Bug 1206739

Summary: Review Request: python-crypto2.1 - Cryptography library for Python
Product: [Fedora] Fedora Reporter: Othman Madjoudj <athmanem>
Component: Package ReviewAssignee: Nobody's working on this, feel free to take it <nobody>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: crosa, package-review, paul
Target Milestone: ---Flags: crosa: fedora-review+
gwync: fedora-cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: python-crypto2.1-2.1.0-4.el6 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-05-14 20:04:09 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1206737    
Attachments:
Description Flags
SPEC file with mentioned changes
none
Patch for setup.py none

Description Othman Madjoudj 2015-03-27 22:47:22 UTC
Spec URL: https://athmane.fedorapeople.org/pkgs/fabric-el6/python-crypto2.1.spec
SRPM URL: https://athmane.fedorapeople.org/pkgs/fabric-el6/python-crypto2.1-2.1.0-1.el6.src.rpm

Description: 

Python-crypto is a collection of both secure hash functions (such as MD5 and
SHA), and various encryption algorithms (AES, DES, RSA, ElGamal etc.).

This is a parallel update for EPEL6


Fedora Account System Username: athmane

Comment 1 Othman Madjoudj 2015-03-27 22:48:03 UTC
PS. I need this to push fabric in EPEL6

Comment 2 Cleber Rosa 2015-04-16 02:32:09 UTC
Created attachment 1015008 [details]
SPEC file with mentioned changes

Comment 3 Cleber Rosa 2015-04-16 02:33:15 UTC
Created attachment 1015009 [details]
Patch for setup.py

Comment 4 Cleber Rosa 2015-04-16 02:34:28 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package contains BR: python2-devel or python3-devel

The current build rquirement is set as:

BuildRequires:	python-devel >= 2.2, gmp-devel >= 4.1

But should be:

BuildRequires:	python2-devel, gmp-devel >= 4.1

Or even better IMHO:

BuildRequires:	python2-devel
BuildRequires:	gmp-devel >= 4.1

This is necessary because this package targets EPEL6 where
python2-devel is not part of the standard buildroot.

- Package provides "pycrypto".

I'm not 100% sure on this, but IMHO it looks like this, exposed as Python module at the "Crypto21" namespace can not be considered a provider of "pycrypto".

- python-crypto2.1-use-Crypto21.patch

This patch should only rename module names from 'Crypto.*' to
'Crypto21.*' and not all occurences of 'Crypto'.  That is, it probably
be a 's/Crypto\./Crypto21/g' instead of a 's/Crypto/Crypto21/g'
because of false positives such as:

-# into PyCrypto (the "Modifications").
+# into PyCrypto21 (the "Modifications").

and:

-    This supports the API for Cryptographic Hash Functions (PEP 247).
+    This supports the API for Crypto21graphic Hash Functions (PEP 247).

and also:

-class CryptoWarning(Warning):
-    """Base class for PyCrypto warnings"""
+class Crypto21Warning(Warning):
+    """Base class for PyCrypto21 warnings"""

This will make code that depende on python-crypto fail because symbol
names are different.

- I'm attaching a modified version of the SPEC with a few
  changes/suggestions and also the added patch.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
     Reviewer note: unversioned .so files are Python modules and not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
     Note: mix of Public Domain and small bits with Python license.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "*No copyright* BSD", "Unknown or generated". 123 files have unknown
     license. Detailed output of licensecheck in /home/cleber/1206739-python-
     crypto2.1/licensecheck.txt
     Reviewer note: src/AES.c may have triggered a false positive on
     fedora-review, since it is actually public domain and there's no
     mention of BSD license. All other files mentioned are also in the
     public domain.
[x]: If the package is under multiple licenses, the licensing breakdown must
     be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
     Reviewer note: compilation is called from setup.py, which is
     called with CFLAGS=%{optflags}, so, check.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[!]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf %{buildroot} present but not required
     Reviewer note: confirmed it's not required after a build with a
     modified SPEC.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Reviewer note: installed in parallel with python-crypto and no
     conflict was found.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
     Reviewer Note: there's an issue with [Build]Requires and python-devel
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 194560 bytes in 22 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: %clean present but not required
     Reviewer Note: should not be present once package does not target
     EPEL 5 or Fedora <= 12.
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[!]: Package functions as described.
[-]: Latest version is packaged.
     Reviewer Note: the current package version is a requirement for
     another package.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-crypto2.1-2.1.0-1.fc20.x86_64.rpm
          python-crypto2.1-2.1.0-1.fc20.src.rpm
python-crypto2.1.x86_64: W: spelling-error %description -l en_US crypto -> crypt, crypts, crypt o
python-crypto2.1.x86_64: W: file-not-utf8 /usr/share/doc/python-crypto2.1/LEGAL/copy/stmts/Paul_Swartz.mbox
python-crypto2.1.x86_64: E: backup-file-in-package /usr/share/doc/python-crypto2.1/LEGAL/copy/LICENSE.orig
python-crypto2.1.src: W: spelling-error %description -l en_US crypto -> crypt, crypts, crypt o
python-crypto2.1.src:63: W: macro-in-comment %{__python}
python-crypto2.1.src:14: W: mixed-use-of-spaces-and-tabs (spaces: line 14, tab: line 4)
2 packages and 0 specfiles checked; 1 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
python-crypto2.1 (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libgmp.so.10()(64bit)
    libpthread.so.0()(64bit)
    libpython2.7.so.1.0()(64bit)
    python(abi)
    rtld(GNU_HASH)



Provides
--------
python-crypto2.1:
    pycrypto
    python-crypto2.1
    python-crypto2.1(x86-64)



Unversioned so-files
--------------------
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Cipher/AES.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Cipher/ARC2.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Cipher/ARC4.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Cipher/Blowfish.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Cipher/CAST.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Cipher/DES.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Cipher/DES3.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Cipher/XOR.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Hash/MD2.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Hash/MD4.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Hash/RIPEMD160.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Hash/SHA256.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/PublicKey/_fastmath.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Util/_counter.so
python-crypto2.1: /usr/lib64/python2.7/site-packages/Crypto21/Util/strxor.so

Source checksums
----------------
http://ftp.dlitz.net/pub/dlitz/crypto/pycrypto/pycrypto-2.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : 253e1c22ea0249f0429df4f7e2eb973b119c83b146c0f421298f5e8e6822d8a2
  CHECKSUM(SHA256) upstream package : 253e1c22ea0249f0429df4f7e2eb973b119c83b146c0f421298f5e8e6822d8a2


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -b 1206739
Buildroot used: fedora-20-x86_64
Active plugins: Python, Generic, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, fonts, Haskell, Ocaml, Perl, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG


Other
=====

Parallel installation:
----------------------

Parallel installation is working fine:

$ rpm -qa | grep python-crypto
python-crypto2.1-2.1.0-1.el6.x86_64
python-crypto-2.0.1-22.el6.x86_64

Comment 5 Othman Madjoudj 2015-04-18 14:01:28 UTC
Please find updated SPEC/SRPM:


%changelog
* Sat Apr 18 2015 Athmane Madjoudj <athmane>  2.1.0-3
- Rebase use Crypto21 patch.
- Remove pycrypto provide.



Spec URL: https://athmane.fedorapeople.org/pkgs/fabric-el6/python-crypto2.1.spec
SRPM URL: https://athmane.fedorapeople.org/pkgs/fabric-el6/python-crypto2.1-2.1.0-3.el6.src.rpm

Comment 6 Cleber Rosa 2015-04-23 18:15:53 UTC
New version has fixed issues spotted during the review and works as expected.

Comment 7 Othman Madjoudj 2015-04-23 18:58:19 UTC
New Package SCM Request
=======================
Package Name: python-crypto2.1
Short Description: Cryptography library for Python
Upstream URL: http://www.pycrypto.org/
Owners: athmane
Branches: el6

Comment 8 Gwyn Ciesla 2015-04-23 20:01:56 UTC
Git done (by process-git-requests).

Comment 9 Fedora Update System 2015-04-23 20:38:49 UTC
python-crypto2.1-2.1.0-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-crypto2.1-2.1.0-3.el6

Comment 10 Paul Howarth 2015-04-24 12:46:27 UTC
I believe this package should be patched for CVE-2012-2417. The patch for 2.0.1 in the el5 branch of python-crypto should do the trick.

Comment 11 Fedora Update System 2015-04-24 16:01:50 UTC
python-crypto2.1-2.1.0-4.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/python-crypto2.1-2.1.0-4.el6

Comment 12 Othman Madjoudj 2015-04-24 16:06:44 UTC
(In reply to Paul Howarth from comment #10)
> I believe this package should be patched for CVE-2012-2417. 

True, it is fixed in -4, thank you for noticing this issue.

Comment 13 Fedora Update System 2015-04-25 23:51:54 UTC
Package python-crypto2.1-2.1.0-4.el6:
* should fix your issue,
* was pushed to the Fedora EPEL 6 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing python-crypto2.1-2.1.0-4.el6'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2015-5985/python-crypto2.1-2.1.0-4.el6
then log in and leave karma (feedback).

Comment 14 Fedora Update System 2015-05-14 20:04:09 UTC
python-crypto2.1-2.1.0-4.el6, python-paramiko1.10-1.10.1-2.el6, fabric-1.6.2-2.el6 has been pushed to the Fedora EPEL 6 stable repository.